lightoj 1326 - Race dp+预处理

1326 - Race

PDF (English) Statistics Forum
Time Limit: 1 second(s) Memory Limit: 32 MB

Disky and Sooma, two of the biggest mega minds of Bangladesh went to a far country. They ate, coded and wandered around, even in their holidays. They passed several months in this way. But everything has an end. A holy person, Munsiji came into their life.
Munsiji took them to derby (horse racing). Munsiji enjoyed the race, but as usual Disky and Sooma did their as usual task instead of passing some romantic moments. They were thinking- in how many ways a race can finish! Who knows, maybe this is their romance!

In a race there are n horses. You have to output the number of ways the race can finish. Note that, more than one horse may get the same position. For example, 2 horses can finish in 3 ways.

1.      Both first

2.      horse1 first and horse2 second

3.      horse2 first and horse1 second

Input

Input starts with an integer T (≤ 1000), denoting the number of test cases.

Each case starts with a line containing an integer n (1 ≤ n ≤ 1000).

Output

For each case, print the case number and the number of ways the race can finish. The result can be very large, print the result modulo 10056.

Sample Input

Output for Sample Input


3

1

2

3


Case 1: 1

Case 2: 3

Case 3: 13

题意:问n匹马赛跑,一共有多少结局。

两匹马有三种结局

1.      Both first

2.      horse1 first and horse2 second

3.      horse2 first and horse1 second

做法:

dp[i][j]  i代表有几匹马,j代表有多少团。

把一样快的马放在一个团里。   按团算 ,两匹马 有 两种,  平局 一个团,dp[2][1]计数1,不平局,有两个团,dp[2][2]计数2。   三匹马的时候,dp[3][1]=dp[2][1]*1;  dp[3][2]=dp[2][1]*2+dp[2][2]*2;   dp[3][3]=dp[2][2]*3

然后dp就很好推了。

要预处理不然会超时。

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <malloc.h>
#include <ctype.h>
#include <math.h>
#include <string>
#include <iostream>
#include <algorithm>
using namespace std;
#include <stack>
#include <queue>
#include <vector>
#include <deque>
#include <set>
#include <map>
int dp[1010][1010];
int aa[1010];
int main()
{
	int t,n;
	int mod=10056;
	scanf("%d",&t);
	int cas=1;
	int ans;
	n=1000;

	memset(dp,0,sizeof dp);
	dp[1][1]=1;
	for(int i=2;i<=n;i++)//当前第几只
	{
		for(int j=1;j<=i;j++)//几团
		{
			dp[i][j]+=(dp[i-1][j]*j+dp[i-1][j-1]*j)%mod;
		}
	} 

	for(int i=1;i<=n;i++)
	{
		ans=0;
		for(int j=1;j<=i;j++)
		{
			ans=(ans+dp[i][j])%mod;;
		}
		aa[i]=ans;
	}
	while(t--)
	{
		scanf("%d",&n);
		printf("Case %d: %d\n",cas++,aa[n]);
	}
	return 0;
}
时间: 2024-12-28 16:17:34

lightoj 1326 - Race dp+预处理的相关文章

LightOJ 1326 - Race(第二类斯特林数啊 )

题目链接:http://lightoj.com/volume_showproblem.php?problem=1326 百度百科:斯特林数 ACdreamer:第一类Stirling数和第二类Stirling Disky and Sooma, two of the biggest mega minds of Bangladesh went to a far country. They ate, coded and wandered around, even in their holidays.

LightOJ 1038 Race to 1 Again 期望 记忆化dp

题目链接:点击打开链接 1038 - Race to 1 Again PDF (English) Statistics Forum Time Limit: 2 second(s) Memory Limit: 32 MB Rimi learned a new thing about integers, which is - any positive integer greater than 1 can be divided by its divisors. So, he is now playin

Lightoj 1038 - Race to 1 Again (概率DP)

题目链接: Lightoj  1038 - Race to 1 Again 题目描述: 给出一个数D,每次可以选择数D的一个因子,用数D除上这个因子得到一个新的数D,为数D变为1的操作次数的期望为多少? 解题思路: 概率DP咯,对于只知道期望是:E(X) = X1*p(X1) + X2*p(X2) + …… + Xn*p(Xn)的窝,拿这个题目没有一点办法.然后看了讨论版,发现总会有一些神人存在. 求操作次数的期望时,先设定第i个因子给期望的贡献为Ti,那么有:E = (T1 + T2 + T3

LightOJ 1364 树形DP

52张扑克牌,问拿到指定数量的4个花色的最少次数期望是多少,其中拿到joker必须马上将其视作一种花色,且要使后续期望最小. 转移很容易想到,主要是两张joker的处理,一个状态除了普通的4个方向的转移,当没拿到joker时还要增加拿到joker的期望,根据题意直接在当前状态下找最小的期望计算即可. /** @Date : 2017-08-29 17:58:59 * @FileName: LightOJ 1364 概率DP.cpp * @Platform: Windows * @Author :

LightOJ 1038 - Race to 1 Again 【DP】

题目链接:http://www.lightoj.com/volume_showproblem.php?problem=1038 题意:题目很短,不叙述了. 解法:dp 代码: #include <stdio.h> #include <ctime> #include <math.h> #include <limits.h> #include <complex> #include <string> #include <functio

LightOJ 1038 - Race to 1 Again(期望+DP)

题目链接:http://lightoj.com/volume_showproblem.php?problem=1038 题意是:给你一个N (1 ≤ N ≤ 105) 每次N都随机选一个因子d,然后让N=N/d, 求N变成1的次数的期望: 当 N = 2 时 2有两个因子:1,2 E[2] = E[1]/2 + E[2]/2 + 1;因此可以求出E[2]; 当N = 8 时 8有4个因子1 2 4 8; E[8] = E[1]/4 + E[2]/4 + E[4]/4 + E[8]/4+ 1;因此

hdu 5693 &amp;&amp; LightOj 1422 区间DP

hdu 5693 题目链接http://acm.hdu.edu.cn/showproblem.php?pid=5693 等差数列当划分细了后只用比较2个或者3个数就可以了,因为大于3的数都可以由2和3组合成. 区间DP,用dp[i][j]表示在i到j之间可以删除的最大数,枚举区间长度,再考虑区间两端是否满足等差数列(这是考虑两个数的),再i到j之间枚举k,分别判断左端点右端点和k是否构成等差数列(还是考虑两个数的),判断左端点,k,右端点是否构成等差数列(这是老驴三个数的) 1 #include

LightOJ 1038 - Race to 1 Again (给一个数,用这个数的因数除以这个数,直到为1时,求除的次数的期望。)(概率)

题意:http://www.lightoj.com/volume_showproblem.php?problem=1038 题意:给一个数,用这个数的因数除以这个数,直到为1时,求除的次数的期望. 设一个数的约数有M个,E[n] = (E[a[1]]+1)/M+(E[a[2]]+1)/M+...+(E[a[M]]+1)/M 一个数最大的约数是它自己. 则有,E[n] = (E[a[1]]+1)/M+(E[a[2]]+1)/M+...+(E[n]+1)/M (M-1)*E[n]=E[a[1]]+E

Codeforces 147B Smile House(DP预处理 + 倍增)

题目链接  Smile House 题意  给定一个$n$个点的有向图,求一个点数最少的环,使得边权之和$>0$,这里的环可以重复经过点和边.   满足  $n <= 300$ 首先答案肯定是单调的,但是观察发现只有当我们给所有的点加一个自环的时候才满足这个性质. 考虑$DP$.设$f[i][j][k]$为长度为$i$,从$j$走到$k$能经过的最大边权和. 那么$f[i][j][k] = min(f[i-1][j][l] + g[l][k])$,这样的预处理是$O(n^{4})$的,$TLE